# Release notes for Gluster 3.12.1

This is a bugfix release. The [Release Notes for 3.12.0](3.12.0.md),
     [3.12.1](3.12.1.md) contain a listing of all the new features that
     were added and bugs fixed in the GlusterFS 3.12 stable release.

## Major changes, features and limitations addressed in this release
     No Major changes

## Major issues
1. Expanding a gluster volume that is sharded may cause file corruption
    - Sharded volumes are typically used for VM images, if such volumes are
  expanded or possibly contracted (i.e add/remove bricks and rebalance) there
  are reports of VM images getting corrupted.
    - The last known cause for corruption (Bug #1465123) has a fix with this
  release. As further testing is still in progress, the issue is retained as
  a major issue.
    - Status of this bug can be tracked here, #1465123

## Bugs addressed

     A total of 12 patches have been merged, addressing 11 bugs

- [#1486538](https://bugzilla.redhat.com/1486538): [geo-rep+qr]: Crashes observed at slave from qr_lookup_sbk during rename/hardlink/rebalance
- [#1486557](https://bugzilla.redhat.com/1486557): Log entry of files skipped/failed during rebalance operation
- [#1487033](https://bugzilla.redhat.com/1487033): rpc: client_t and related objects leaked due to incorrect ref counts
- [#1487319](https://bugzilla.redhat.com/1487319): afr: check op_ret value in __afr_selfheal_name_impunge
- [#1488119](https://bugzilla.redhat.com/1488119): scripts: mount.glusterfs contains non-portable bashisms
- [#1488168](https://bugzilla.redhat.com/1488168): Launch metadata heal in discover code path.
- [#1488387](https://bugzilla.redhat.com/1488387): gluster-blockd process crashed and core generated
- [#1488718](https://bugzilla.redhat.com/1488718): [RHHI] cannot boot vms created from template when disk format = qcow2
- [#1489260](https://bugzilla.redhat.com/1489260): Crash in dht_check_and_open_fd_on_subvol_task()
- [#1489296](https://bugzilla.redhat.com/1489296): glusterfsd (brick) process crashed
- [#1489511](https://bugzilla.redhat.com/1489511): return ENOSYS for 'non readable' FOPs
